// PPgGeneral.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "PPgGeneral.h"


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// CPPgGeneral dialog

IMPLEMENT_DYNAMIC(CPPgGeneral, CPropertyPage)

BEGIN_MESSAGE_MAP(CPPgGeneral, CPropertyPage)
	ON_EN_CHANGE(IDC_NICK, OnSettingsChange)
	ON_EN_CHANGE(IDC_TOOLTIPDELAY, OnSettingsChange)
	ON_CBN_SELCHANGE(IDC_LANGS, OnSettingsChange)
	ON_BN_CLICKED(IDC_BEEPER, OnSettingsChange)
	ON_BN_CLICKED(IDC_SPLASHON, OnSettingsChange)
	ON_BN_CLICKED(IDC_NOTIFY, OnSettingsChange)
	ON_BN_CLICKED(IDC_ONLINESIG, OnSettingsChange)
	ON_BN_CLICKED(IDC_MULTIPLE, OnSettingsChange)
	ON_BN_CLICKED(IDC_DC_CLIENT, OnSettingsChange)
	ON_BN_CLICKED(IDC_MP_STANDARD, OnSettingsChange)
	ON_BN_CLICKED(IDC_MP_HIGH, OnSettingsChange)
	ON_BN_CLICKED(IDC_WEBSVEDIT , OnBnClickedEditWebservices)
	ON_BN_CLICKED(IDC_ED2KFIX, OnBnClickedEd2kfix)
	ON_BN_CLICKED(IDC_AUTOTAKEED2KLINKS, OnBnClickedAutoTakeED2KLinks)
	ON_BN_CLICKED(IDC_FAKE_CHECKUPDATEONSTART, OnSettingsChange)
	ON_BN_CLICKED(IDC_FAKE_UPDATE, OnBnClickedFakeUpdate)
	ON_EN_CHANGE(IDC_FAKE_LIST_URL, OnSettingsChange)
	ON_WM_HSCROLL()
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_3DDEPTH, On3DDepth)
	ON_BN_CLICKED(IDC_WATCH_CLIPBOARD, OnSettingsChange)
END_MESSAGE_MAP()

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CPPgGeneral::CPPgGeneral()
	: CPropertyPage(CPPgGeneral::IDD),
	  beepOnErrors(FALSE),
	  showSplashscreen(FALSE),
	  allowMultipleInstances(FALSE),
	  onlineSignature(FALSE),
	  doubleClickClientDetails(FALSE),
	  autoTakeEd2kLinks(FALSE),
	  userNick(_T("")),
	  tooltipDelay(_T("")),
	  mainProcess(0),
	  updateFakeList(FALSE),
	  watchClipboard(FALSE)
{
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CPPgGeneral::~CPPgGeneral()
{
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CPPgGeneral::DoDataExchange(CDataExchange *pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LANGS, languageCombo);
	DDX_Control(pDX, IDC_PREVIEW, m_3DPreview);
	DDX_Control(pDX, IDC_3DDEPTH, threeDSlider);
	DDX_Control(pDX, IDC_NICK, userNickEdit);
	DDX_Control(pDX, IDC_BEEPER, beepOnErrorsCheck);
	DDX_Control(pDX, IDC_SPLASHON, showSplashscreenCheck);
	DDX_Control(pDX, IDC_MULTIPLE, allowMultipleInstancesCheck);
	DDX_Control(pDX, IDC_ONLINESIG, onlineSignatureCheck);
	DDX_Control(pDX, IDC_DC_CLIENT, doubleClickClientDetailsCheck);
	DDX_Control(pDX, IDC_ED2KFIX, ed2kFixButton);
	DDX_Control(pDX, IDC_AUTOTAKEED2KLINKS, autoTakeEd2kLinksCheck);
	DDX_Check(pDX, IDC_AUTOTAKEED2KLINKS, autoTakeEd2kLinks);
	DDX_Check(pDX, IDC_BEEPER, beepOnErrors);
	DDX_Check(pDX, IDC_SPLASHON, showSplashscreen);
	DDX_Check(pDX, IDC_MULTIPLE, allowMultipleInstances);
	DDX_Check(pDX, IDC_ONLINESIG, onlineSignature);
	DDX_Check(pDX, IDC_DC_CLIENT, doubleClickClientDetails);
	DDX_Text(pDX, IDC_TOOLTIPDELAY, tooltipDelay);
	DDX_Text(pDX, IDC_NICK, userNick);
	DDX_Control(pDX, IDC_NICK_FRM, nickDesc);
	DDX_Control(pDX, IDC_LANG_FRM, languageDesc);
	DDX_Control(pDX, IDC_MISC_FRM, miscDesc);
	DDX_Control(pDX, IDC_TOOLTIPDELAY_LBL, tooltipDelayDesc);
	DDX_Control(pDX, IDC_3DDEP, threeDDepDesc);
	DDX_Radio(pDX, IDC_MP_STANDARD, mainProcess);
	DDX_Control(pDX, IDC_MP_STANDARD, standardProcessRadio);
	DDX_Control(pDX, IDC_MP_HIGH, highProcessRadio);
	DDX_Control(pDX, IDC_MAINPROCESS, mainProcessDesc);
	DDX_Control(pDX, IDC_WEBSVEDIT, webSvEditButton);
	DDX_Check(pDX, IDC_FAKE_CHECKUPDATEONSTART, updateFakeList);
	DDX_Control(pDX, IDC_FAKE_CHECKUPDATEONSTART, updateFakeListCheck);
	DDX_Control(pDX, IDC_FAKE_UPDATE, updateFakeListButton);
	DDX_Control(pDX, IDC_FAKE_LIST_URL_LBL, updateFakeListURLLabel);
	DDX_Text(pDX, IDC_FAKE_LIST_URL, updateFakeListURL);
	DDX_Control(pDX, IDC_WATCH_CLIPBOARD, watchClipboardCheck);
	DDX_Check(pDX, IDC_WATCH_CLIPBOARD, watchClipboard);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL CPPgGeneral::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	userNickEdit.SetLimitText(MAX_NICK_LENGTH);

	ed2kFixButton.EnableWindow(!CheckIsRegistrySet());
	LoadSettings();
	DrawPreview();
	Localize();

	return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CPPgGeneral::LoadLanguagesCombo(void)
{
	static const WORD wLangs[] =
	{
		MAKELANGID(LANG_BASQUE, SUBLANG_DEFAULT),					// Basque
		MAKELANGID(LANG_BELARUSIAN, SUBLANG_DEFAULT),				// Belarusian
		MAKELANGID(LANG_CATALAN, SUBLANG_DEFAULT),					// Catalan
		MAKELANGID(LANG_CHINESE, SUBLANG_CHINESE_SIMPLIFIED),		// Chinese (simplified)
		MAKELANGID(LANG_CHINESE, SUBLANG_CHINESE_TRADITIONAL),		// Chinese (traditional)
		MAKELANGID(LANG_CROATIAN, SUBLANG_DEFAULT),					// Croatian
		MAKELANGID(LANG_CZECH, SUBLANG_DEFAULT),					// Czech
		MAKELANGID(LANG_DANISH, SUBLANG_DEFAULT),					// Danish
		MAKELANGID(LANG_DUTCH, SUBLANG_DEFAULT),					// Dutch
		MAKELANGID(LANG_ENGLISH, SUBLANG_DEFAULT),					// English
		MAKELANGID(LANG_SPECIAL, SUBLNG_EXTREMADURAN),				// Extremaduran
		MAKELANGID(LANG_FINNISH, SUBLANG_DEFAULT),					// Finnish
		MAKELANGID(LANG_FRENCH, SUBLANG_DEFAULT),					// French
		MAKELANGID(LANG_GERMAN, SUBLANG_DEFAULT),					// German
		MAKELANGID(LANG_GREEK, SUBLANG_DEFAULT),					// Greek
		MAKELANGID(LANG_HEBREW, SUBLANG_DEFAULT),					// Hebrew
#if 0
		MAKELANGID(LANG_INDONESIAN, SUBLANG_DEFAULT),				// Indonesian
#endif
		MAKELANGID(LANG_ITALIAN, SUBLANG_DEFAULT),					// Italian
		MAKELANGID(LANG_KOREAN, SUBLANG_DEFAULT),					// Korean
		MAKELANGID(LANG_LITHUANIAN, SUBLANG_DEFAULT),				// Lithuanian
		MAKELANGID(LANG_NORWEGIAN, SUBLANG_NORWEGIAN_BOKMAL),		// Norwegian (Bokmal)
		MAKELANGID(LANG_POLISH, SUBLANG_DEFAULT),					// Polish
		MAKELANGID(LANG_PORTUGUESE, SUBLANG_PORTUGUESE),			// Portuguese (Portugal)
		MAKELANGID(LANG_PORTUGUESE, SUBLANG_PORTUGUESE_BRAZILIAN),	// Portuguese (Brazilian)
		MAKELANGID(LANG_ROMANIAN, SUBLANG_DEFAULT),					// Romanian
		MAKELANGID(LANG_RUSSIAN, SUBLANG_DEFAULT),					// Russian
		MAKELANGID(LANG_SPANISH, SUBLANG_SPANISH),					// Spanish
		MAKELANGID(LANG_TURKISH, SUBLANG_DEFAULT)					// Turkish
	};

	CString	strLang;

	for (int i = 0; i < ELEMENT_COUNT(wLangs); i++)
	{
		if (PRIMARYLANGID(wLangs[i]) == LANG_SPECIAL)
		{
		//	Unique languages not supported by OS (language names are left untranslated)
			switch (SUBLANGID(wLangs[i]))
			{
				case SUBLNG_EXTREMADURAN:
					strLang = _T("Extremaduran");
					break;
			}
		}
		else
		{
			GetLocaleInfo(wLangs[i], LOCALE_SLANGUAGE, strLang.GetBuffer(128), 128);
			strLang.ReleaseBuffer();

		//	No sublangs in brackets for the following languages
			switch(PRIMARYLANGID(wLangs[i]))
			{
				case	LANG_ENGLISH:
				case 	LANG_GERMAN:
				case 	LANG_FRENCH:
				case 	LANG_SPANISH:
				case 	LANG_DUTCH:
				case	LANG_ITALIAN:
				{
					int iBracket = strLang.Find(_T(" ("));
					if(iBracket > 0)
						strLang.Truncate(iBracket);
					break;
				}
			}
		}
	//	Current position in the automatically sorted list
		int		iRc = languageCombo.AddString(strLang);

		if (iRc >= 0)
		{
			languageCombo.SetItemData(iRc, wLangs[i]);
			if (wLangs[i] == m_pPrefs->GetLanguageID())
			{
			//	Select default language
				languageCombo.SetCurSel(iRc);
			}
		}
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CPPgGeneral::LoadSettings(void)
{
	userNick = m_pPrefs->GetUserNick();

	LoadLanguagesCombo();

	beepOnErrors = m_pPrefs->IsErrorBeepEnabled();
	showSplashscreen = m_pPrefs->UseSplashScreen();
	allowMultipleInstances = m_pPrefs->GetMultiple();
	onlineSignature = m_pPrefs->IsOnlineSignatureEnabled();
	doubleClickClientDetails = m_pPrefs->GetDetailsOnClick();
	autoTakeEd2kLinks = m_pPrefs->AutoTakeED2KLinks();
	mainProcess = (m_pPrefs->GetMainProcessPriority()) ? 1 : 0;
	updateFakeList = m_pPrefs->IsUpdateFakeStartupEnabled();
	updateFakeListURL = m_pPrefs->GetFakeListURL();
	watchClipboard = m_pPrefs->IsWatchClipboard4ED2KLinks();
	tooltipDelay.Format(_T("%u"), m_pPrefs->GetToolTipDelay());

	threeDSlider.SetRange(-5, 5, true);
	int tmp = m_pPrefs->Get3DDepth();
	if (tmp > 5)
		tmp -= 256;
	threeDSlider.SetPos(tmp);

	UpdateData(FALSE);

	SetModified(FALSE);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL CPPgGeneral::OnApply()
{
	if(m_bModified)
	{
		UpdateData(TRUE);

		if (!userNick.IsEmpty())
			m_pPrefs->SetUserNick(userNick);

		int iTmp = languageCombo.GetCurSel();

		if (iTmp != CB_ERR)
		{
			WORD byNewLang = languageCombo.GetItemData(iTmp);
			if (m_pPrefs->GetLanguageID() != byNewLang)
			{
				m_pPrefs->SetLanguageID(byNewLang);
				if (g_App.m_pPrefs->IsNTBased())
				{
					SetThreadLocale(byNewLang);
				}
				g_App.m_pMDlg->m_dlgPreferences.Localize();
				g_App.m_pMDlg->m_dlgStatistics.Localize();
				g_App.m_pMDlg->m_wndServer.Localize();
				g_App.m_pMDlg->m_wndTransfer.Localize();
				g_App.m_pMDlg->m_dlgSearch.Localize();
				g_App.m_pMDlg->m_wndSharedFiles.Localize();
				g_App.m_pMDlg->m_wndChat.Localize();
				g_App.m_pMDlg->Localize();
				g_App.m_pMDlg->m_wndIRC.Localize();
			}
		}

		m_pPrefs->SetErrorBeepEnabled(beepOnErrors);
		m_pPrefs->SetUseSplashScreen(showSplashscreen);
		m_pPrefs->SetOnlineSignatureEnabled(onlineSignature);
		m_pPrefs->SetDetailsOnClick(doubleClickClientDetails);
		m_pPrefs->SetMultiple(allowMultipleInstances);

		byte	byteTmp = ((CSliderCtrl*)GetDlgItem(IDC_3DDEPTH))->GetPos();

		if (byteTmp != m_pPrefs->Get3DDepth())
		{
			m_pPrefs->Set3DDepth(byteTmp);
		//	Status bar format is changed, update the download list
			g_App.m_pMDlg->m_wndTransfer.m_ctlDownloadList.Invalidate();
		//	Update upload lists only if upload progress bars are enabled
			if (m_pPrefs->IsUploadPartsEnabled())
			{
				g_App.m_pMDlg->m_wndTransfer.m_ctlUploadList.Invalidate();
				g_App.m_pMDlg->m_wndTransfer.m_ctlQueueList.Invalidate();		
			}
		}

		m_pPrefs->SetAutoTakeED2KLinks(autoTakeEd2kLinks);
		m_pPrefs->SetUpdateFakeStartup(updateFakeList);
		m_pPrefs->SetFakeListURL(updateFakeListURL.Trim());
		m_pPrefs->SetWatchClipboard4ED2KLinks(watchClipboard);

		if ((iTmp = _tstoi(tooltipDelay)) > 60)
			iTmp = 60;
		m_pPrefs->SetToolTipDelay(iTmp);

		g_App.m_pMDlg->m_wndTransfer.m_ttip.SetDelayTime(TTDT_INITIAL, g_App.m_pPrefs->GetToolTipDelay()*1000);
		g_App.m_pMDlg->m_wndServer.m_ttip.SetDelayTime(TTDT_INITIAL, g_App.m_pPrefs->GetToolTipDelay()*1000);
		g_App.m_pMDlg->m_ttip.SetDelayTime(TTDT_INITIAL, g_App.m_pPrefs->GetToolTipDelay()*1000);
		g_App.m_pMDlg->m_dlgSearch.m_ttip.SetDelayTime(TTDT_INITIAL, g_App.m_pPrefs->GetToolTipDelay()*1000);
		g_App.m_pMDlg->m_wndSharedFiles.m_ttip.SetDelayTime(TTDT_INITIAL, g_App.m_pPrefs->GetToolTipDelay()*1000);
		g_App.m_pMDlg->m_wndChat.m_ttip.SetDelayTime(TTDT_INITIAL, g_App.m_pPrefs->GetToolTipDelay()*1000);

		m_pPrefs->SetMainProcessPriority((mainProcess == 0) ? 0 : 1);

		SetModified(FALSE);
	}

	return CPropertyPage::OnApply();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CPPgGeneral::Localize(void)
{
	if(::IsWindow(m_hWnd))
	{
		SetWindowText(GetResString(IDS_PW_GENERAL));
		nickDesc.SetWindowText(GetResString(IDS_PW_NICK));
		languageDesc.SetWindowText(GetResString(IDS_PW_LANG));
		miscDesc.SetWindowText(GetResString(IDS_PW_MISC));
		beepOnErrorsCheck.SetWindowText(GetResString(IDS_PW_BEEP));
		showSplashscreenCheck.SetWindowText(GetResString(IDS_PW_SPLASH));
		tooltipDelayDesc.SetWindowText(GetResString(IDS_PW_TOOL));
		onlineSignatureCheck.SetWindowText(GetResString(IDS_PREF_ONLINESIG));
		allowMultipleInstancesCheck.SetWindowText(GetResString(IDS_MULTIPLE));
		doubleClickClientDetailsCheck.SetWindowText(GetResString(IDS_DC_CLIENT));
		threeDDepDesc.SetWindowText(GetResString(IDS_3DDEP));
		mainProcessDesc.SetWindowText(GetResString(IDS_MAINPROCESS_LBL));
		standardProcessRadio.SetWindowText(GetResString(IDS_HASHPRIO_STANDARD));
		highProcessRadio.SetWindowText(GetResString(IDS_PRIOHIGH));
		webSvEditButton.SetWindowText(GetResString(IDS_WEBSVEDIT));
		ed2kFixButton.SetWindowText(GetResString(IDS_ED2KLINKFIX));
		autoTakeEd2kLinksCheck.SetWindowText(GetResString(IDS_AUTOTAKEED2KLINKS));
		updateFakeListButton.SetWindowText(GetResString(IDS_SV_UPDATE));
		updateFakeListCheck.SetWindowText(GetResString(IDS_FAKE_CHECKUPDATEONSTART));
		updateFakeListURLLabel.SetWindowText(GetResString(IDS_FAKE_LIST_URL_LBL));
		watchClipboardCheck.SetWindowText(GetResString(IDS_WATCH_CLIPBOARD));
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CPPgGeneral::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	SetModified(TRUE);
	UpdateData(false);
	CPropertyPage::OnHScroll(nSBCode, nPos, pScrollBar);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CPPgGeneral::DrawPreview()
{
	m_3DPreview.SetSliderPos(threeDSlider.GetPos());
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CPPgGeneral::On3DDepth(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	DrawPreview();
	*pResult = 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CPPgGeneral::OnBnClickedEditWebservices()
{
	CString	strPath;

	strPath.Format(_T("\"%swebservices.dat\""), g_App.m_pPrefs->GetConfigDir());
	ShellExecute(NULL, _T("open"), g_App.m_pPrefs->GetTxtEditor(), strPath, NULL, SW_SHOW);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CPPgGeneral::OnBnClickedEd2kfix()
{
	Ask4RegFix();
	ed2kFixButton.EnableWindow(!CheckIsRegistrySet());
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CPPgGeneral::OnBnClickedFakeUpdate()
{
	UpdateData(true);

	m_pPrefs->SetFakeListURL(updateFakeListURL);
	g_App.m_pFakeCheck->UpdateFakeList();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
